//InsererHeure_501f.js
// 23.03.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Complter des lgendes par l'heure de la prise de vue

/*
Mes remerciements vont  deux membre du forum "HilfDirSelbst.ch":
 "mac_heibu": l'initiant de ce script
 "drerol74":  fournissait une mthode plus polyvalente pour trouver les images
*/

withSeconds = true; // l'heure y compris les secondes (hh:mm:ss)
//withSeconds = false; // l'heure sans les secondes (hh:mm)

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester, s'il y a un objet slectionn
if (app.selection.length == 0) {
	alert ("Slectionner un bloc, s.v.p.", "Attention");
	exit();
}

// le document au premier plan
var curDoc = app.activeDocument;

// prparer les prfrences GREP pour la rechereche de la chane de texte de la date
app.findGrepPreferences = app.changeGrepPreferences = null;
app.findGrepPreferences.findWhat = "[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{2,4}$";

// dfinir un RegExp pour l'extraction de l'heure
var objRegExp = new RegExp("([0-9]{2}:[0-9]{2}:[0-9]{2})");

// initialiser la variable de texte temporaire
varName = app.activeDocument.textVariables.itemByName("Nom de l'image");

// mmoriser et vrifier la slection
var curSel = app.selection;
var delSel = false;
if (curSel.length == 0) {
	var oneSpread = false;
	for (var s=0; s<curDoc.spreads.length; s++) {
		getObjects(oneSpread, s);
		insTime();
	}
}
else {
	var nItems = curSel.length;
	txtFramesList = new Array ();
	for (var i=0; i<nItems; i++) {
		curItem = curSel[i];
		if (curItem.constructor.name == "TextFrame") {
			txtFramesList.push(curItem);
		}
		else if (curItem.hasOwnProperty("baseline")) {
			txtFramesList.push(curItem.parent.textContainers[0]);
			delSel = true;
		}
		else if (curItem.constructor.name == "Group") {
			getGroupItems(curItem);
		}
	}
	if (txtFramesList.length == 0) {
		alert ("Il n'y a pas de bloc *texte* slectionn.", "Attention");
		exit();
	}
	var actSpread = txtFramesList[0].parent;
	if (actSpread.constructor.name != "Spread") {
		actSpread = actSpread.parent;
	}
	if (actSpread.constructor.name != "Spread") {
		actSpread = app.activeWindow.activeSpread;
	}
	var oneSpread = true;
	var s = actSpread.index;
	getObjects(oneSpread, s);
	insTime();
}

// restaurer les prfrences GREP
app.findGrepPreferences = app.changeGrepPreferences = null;

// dsactiver la slection (si ncessaire)
if (delSel) {
	app.selection = null;
}

// annoncer la fin de l'action
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(999);
// fermer la fentre
dlog.close();


// les fonctions //////////////////////////////////////////////////////////////////////////////////

// dtecter les blocs texte des groupes
function getGroupItems(curItem) {
	var allObjects = curItem.allPageItems;
	for (var n=0; n<allObjects.length; n++) {
		grpItem = allObjects[n];
		if (grpItem.constructor.name == "TextFrame") {
			txtFramesList.push(grpItem);
		}
		else if (grpItem.constructor.name == "Group") {
			getGroupItems(grpItem);
		}
	}
}

// lister les objets de la planche actuelle
function getObjects(oneSpread, s) {
	var allObjects = curDoc.spreads[s].allPageItems;
	if (oneSpread == false) {
		txtFramesList = new Array ();
		for (var n=0; n<allObjects.length; n++) {
			var curObject = allObjects[n];
			if (curObject instanceof TextFrame) {
				txtFramesList.push(curObject);
			}
		}
	}
	itemLinkList = new Array ();
	for (var n=0; n<allObjects.length; n++) {
		var curObject = allObjects[n];
		if (curObject instanceof Rectangle ||curObject instanceof Polygon ||curObject instanceof Oval) {
			try {
				itemLinkList.push(curObject.graphics[0].itemLink);
			}
			catch (e) {
			}
		}
	}
}

// dceler le nom de l'image, extraire l'heure et insrer cette dernire
function insTime() {
	// vrifier le contenu (la date  la fin du paragraphe)
	for (var f=0; f<txtFramesList.length; f++) {
		var okay = "";
		try {
			okay = txtFramesList[f].findGrep();
		}
		catch (e) {
		}
		// quand le contenu du bloc se tremine par une date...
		if (okay.length == 1) {
			// insrer une variable de texte temporaire
			var textVarInstance = txtFramesList[f].parentStory.insertionPoints[-1].textVariableInstances.add();
			textVarInstance.associatedTextVariable = varName;
			// extraire le nom de l'image
			imgName = textVarInstance.resultText.replace("[<>]","","g");
			// supprimer la variable de texte
			textVarInstance.remove();
			var timeStr = "";
			// une boucel  travers l'array 'ItemLink'
			for (var n=0; n<itemLinkList.length; n++) {
				curLink = itemLinkList[n];
				curName = curLink.name;
				if (curName == imgName) {
					try {
						curDate = "" + curLink.linkXmp.creationDate; // date de cration XMP
						// extraire l'heure (avec ou sans secondes)
						if (withSeconds) {
							timeStr = curDate.match(objRegExp)[1];
						}
						else {
							timeStr = curDate.match(objRegExp)[1].slice(0,-3);
						}
						break;
					}
					catch (e) {
					}
				}
			}
			// tenter d'insrer la chane "heure" quand celle-ci n'est pas vide
			if (timeStr != "") {
				try {
					txtFramesList[f].parentStory.insertionPoints[-1].contents = ", " + timeStr;
				}
				catch (e) {
				}
			}
		}
	}
}